diff --git a/MAINTAINERS b/MAINTAINERS
index 08e575faac..f2f7f33d1f 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -895,8 +895,8 @@ F: doc/guides/nics/pfe.rst
 F: drivers/net/pfe/
 F: doc/guides/nics/features/pfe.ini
 
-Pensando ionic
-M: Andrew Boyer <aboyer@pensando.io>
+AMD Pensando ionic
+M: Andrew Boyer <andrew.boyer@amd.com>
 F: drivers/net/ionic/
 F: doc/guides/nics/ionic.rst
 F: doc/guides/nics/features/ionic.ini
diff --git a/doc/guides/nics/ionic.rst b/doc/guides/nics/ionic.rst
index 673700d6ce..24b57fc0f5 100644
--- a/doc/guides/nics/ionic.rst
+++ b/doc/guides/nics/ionic.rst
@@ -1,22 +1,22 @@
 ..  SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
-    Copyright(c) 2018-2020 Pensando Systems, Inc. All rights reserved.
+    Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
 
 IONIC Driver
 ============
 
-The ionic driver provides support for Pensando server adapters.
+The ionic driver provides support for AMD Pensando server adapters.
 It currently supports the below models:
 
-- DSC-25 dual-port 25G Distributed Services Card `(pdf) <https://pensando.io/wp-content/uploads/2020/03/Pensando-DSC-25-Product-Brief.pdf>`__
-- DSC-100 dual-port 100G Distributed Services Card `(pdf) <https://pensando.io/wp-content/uploads/2020/03/Pensando-DSC-100-Product-Brief.pdf>`__
+- DSC-25 dual-port 25G Distributed Services Card
+- DSC-100 dual-port 100G Distributed Services Card
+- DSC-200 dual-port 200G Distributed Services Card `(pdf) <https://www.amd.com/system/files/documents/pensando-dsc-200-product-brief.pdf>`__
 
-Please visit the Pensando web site at https://pensando.io for more information.
-The `Documents <https://pensando.io/documents/>`_ page contains Product Briefs and other product information.
+Please visit the AMD Pensando web site at https://www.amd.com/en/accelerators/pensando for more information.
 
 Identifying the Adapter
 -----------------------
 
-To determine if one or more Pensando DSC Ethernet devices are installed
+To determine if one or more AMD Pensando DSC Ethernet devices are installed
 on the host, check for the PCI devices:
 
    .. code-block:: console
@@ -30,7 +30,7 @@ Firmware Support
 
 The ionic PMD requires firmware which supports 16 segment transmit SGLs.
 This support was added prior to version 1.0. For help upgrading older versions,
-please contact Pensando support.
+please contact AMD Pensando support.
 
 Building DPDK
 -------------
diff --git a/doc/guides/rel_notes/release_22_11.rst b/doc/guides/rel_notes/release_22_11.rst
index 980c91d5d8..552cc5b62c 100644
--- a/doc/guides/rel_notes/release_22_11.rst
+++ b/doc/guides/rel_notes/release_22_11.rst
@@ -78,6 +78,11 @@ New Features
 
   * Added support to set device link down/up.
 
+* **Updated AMD Pensando ionic driver.**
+
+  Updated the ionic PMD with new features and improvements, including:
+
+  * Updated to reflect that Pensando has been acquired by AMD.
 
 Removed Items
 -------------
diff --git a/drivers/net/ionic/ionic.h b/drivers/net/ionic/ionic.h
index a55202b178..31837f050d 100644
--- a/drivers/net/ionic/ionic.h
+++ b/drivers/net/ionic/ionic.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_H_
@@ -15,8 +15,8 @@
 #include "ionic_osdep.h"
 
 #define IONIC_DRV_NAME			"ionic"
-#define IONIC_DRV_DESCRIPTION		"Pensando Ethernet NIC Driver"
-#define IONIC_DRV_VERSION		"0.11.0-49"
+#define IONIC_DRV_DESCRIPTION		"AMD Pensando Ethernet NIC Driver"
+#define IONIC_DRV_VERSION		"1.17.0-65"
 
 /* Vendor ID */
 #define IONIC_PENSANDO_VENDOR_ID	0x1dd8
diff --git a/drivers/net/ionic/ionic_dev.c b/drivers/net/ionic/ionic_dev.c
index 5439b99b2d..a266ea7ddf 100644
--- a/drivers/net/ionic/ionic_dev.c
+++ b/drivers/net/ionic/ionic_dev.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <stdbool.h>
diff --git a/drivers/net/ionic/ionic_dev.h b/drivers/net/ionic/ionic_dev.h
index 38c078efdf..42d192026b 100644
--- a/drivers/net/ionic/ionic_dev.h
+++ b/drivers/net/ionic/ionic_dev.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_DEV_H_
diff --git a/drivers/net/ionic/ionic_ethdev.c b/drivers/net/ionic/ionic_ethdev.c
index d72033c32c..c696311a18 100644
--- a/drivers/net/ionic/ionic_ethdev.c
+++ b/drivers/net/ionic/ionic_ethdev.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <rte_pci.h>
diff --git a/drivers/net/ionic/ionic_ethdev.h b/drivers/net/ionic/ionic_ethdev.h
index 9304e170de..afe4a67743 100644
--- a/drivers/net/ionic/ionic_ethdev.h
+++ b/drivers/net/ionic/ionic_ethdev.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_ETHDEV_H_
diff --git a/drivers/net/ionic/ionic_if.h b/drivers/net/ionic/ionic_if.h
index 45bad9b040..696ca9806e 100644
--- a/drivers/net/ionic/ionic_if.h
+++ b/drivers/net/ionic/ionic_if.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: GPL-2.0 OR Linux-OpenIB OR BSD-3-Clause */
-/* Copyright (c) 2017-2020 Pensando Systems, Inc.  All rights reserved. */
+/* Copyright 2017-2022 Advanced Micro Devices, Inc. All Rights Reserved. */
 
 #ifndef _IONIC_IF_H_
 #define _IONIC_IF_H_
diff --git a/drivers/net/ionic/ionic_lif.c b/drivers/net/ionic/ionic_lif.c
index 799530f7f5..f0c774c1cb 100644
--- a/drivers/net/ionic/ionic_lif.c
+++ b/drivers/net/ionic/ionic_lif.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <rte_malloc.h>
diff --git a/drivers/net/ionic/ionic_lif.h b/drivers/net/ionic/ionic_lif.h
index 9f00ba2973..bb65184f96 100644
--- a/drivers/net/ionic/ionic_lif.h
+++ b/drivers/net/ionic/ionic_lif.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_LIF_H_
diff --git a/drivers/net/ionic/ionic_logs.h b/drivers/net/ionic/ionic_logs.h
index bc10ad1744..9c96112b9d 100644
--- a/drivers/net/ionic/ionic_logs.h
+++ b/drivers/net/ionic/ionic_logs.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_LOGS_H_
diff --git a/drivers/net/ionic/ionic_mac_api.c b/drivers/net/ionic/ionic_mac_api.c
index 411d84b578..6b48a311ec 100644
--- a/drivers/net/ionic/ionic_mac_api.c
+++ b/drivers/net/ionic/ionic_mac_api.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <stdbool.h>
diff --git a/drivers/net/ionic/ionic_mac_api.h b/drivers/net/ionic/ionic_mac_api.h
index ed9e059a63..7db788fd01 100644
--- a/drivers/net/ionic/ionic_mac_api.h
+++ b/drivers/net/ionic/ionic_mac_api.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_API_H_
diff --git a/drivers/net/ionic/ionic_main.c b/drivers/net/ionic/ionic_main.c
index 7301f53342..3f85a155e0 100644
--- a/drivers/net/ionic/ionic_main.c
+++ b/drivers/net/ionic/ionic_main.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <stdbool.h>
diff --git a/drivers/net/ionic/ionic_osdep.h b/drivers/net/ionic/ionic_osdep.h
index 89ed106d11..9ea90b8edd 100644
--- a/drivers/net/ionic/ionic_osdep.h
+++ b/drivers/net/ionic/ionic_osdep.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_OSDEP_
diff --git a/drivers/net/ionic/ionic_regs.h b/drivers/net/ionic/ionic_regs.h
index 3bdec34242..da7b1614a1 100644
--- a/drivers/net/ionic/ionic_regs.h
+++ b/drivers/net/ionic/ionic_regs.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_REGS_H_
diff --git a/drivers/net/ionic/ionic_rx_filter.c b/drivers/net/ionic/ionic_rx_filter.c
index 4b2e907f9f..6d3b0362c8 100644
--- a/drivers/net/ionic/ionic_rx_filter.c
+++ b/drivers/net/ionic/ionic_rx_filter.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <errno.h>
diff --git a/drivers/net/ionic/ionic_rx_filter.h b/drivers/net/ionic/ionic_rx_filter.h
index 773042fcb2..cd176c9f52 100644
--- a/drivers/net/ionic/ionic_rx_filter.h
+++ b/drivers/net/ionic/ionic_rx_filter.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_RX_FILTER_H_
diff --git a/drivers/net/ionic/ionic_rxtx.c b/drivers/net/ionic/ionic_rxtx.c
index 665d085823..82e333ea13 100644
--- a/drivers/net/ionic/ionic_rxtx.c
+++ b/drivers/net/ionic/ionic_rxtx.c
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #include <sys/queue.h>
diff --git a/drivers/net/ionic/ionic_rxtx.h b/drivers/net/ionic/ionic_rxtx.h
index befbe61cef..ff49d52fff 100644
--- a/drivers/net/ionic/ionic_rxtx.h
+++ b/drivers/net/ionic/ionic_rxtx.h
@@ -1,5 +1,5 @@
 /* SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
- * Copyright(c) 2018-2019 Pensando Systems, Inc. All rights reserved.
+ * Copyright 2018-2022 Advanced Micro Devices, Inc. All Rights Reserved.
  */
 
 #ifndef _IONIC_RXTX_H_
diff --git a/drivers/net/ionic/meson.build b/drivers/net/ionic/meson.build
index 487fef1882..c338515e27 100644
--- a/drivers/net/ionic/meson.build
+++ b/drivers/net/ionic/meson.build
@@ -1,5 +1,5 @@
 # SPDX-License-Identifier: (BSD-3-Clause OR GPL-2.0)
-# Copyright(c) 2019 Pensando
+# Copyright 2019-2022 Advanced Micro Devices, Inc. All Rights Reserved.
 
 if is_windows
     build = false